#include "defs.h"

/* error.c */
void sys_error(char *msg);
void i_error(char *msg);
void i_warning(char *msg);
void msg(char *msg);
void yyerror(char *msg);

/* sym.c */
struct symbol *install(char *name, int scope, int type);
struct symbol *lookup(char *name);
char *strsave(char *str);
char *emalloc(int nbytes);

/* trees.c */
Tree tnoop(void);
Tree tseq(Tree e1, Tree e2);
Tree top(int op, Tree e1, Tree e2);
Tree tunop(int op, Tree e1);
Tree tconvert(int op, Tree e1);
Tree tstore(Tree e1, Tree e2);
Tree tname(SYMBOL *sym);
Tree tconst(int ival);
Tree tconstf(double fval);
Tree tcall(Tree e1, char *str);
Tree tcand(Tree test1, Tree test2);
Tree tcor(Tree test1, Tree test2);
Tree tnot(Tree test1);
Tree trel(int op, Tree e1, Tree e2);
Tree targ(Tree e1, Tree args);
Tree tnoargs(void);
Tree tif(Tree e1, Tree e2);
Tree tifelse(Tree e1, Tree e2, Tree e3);
Tree tfor(Tree e1, Tree e2, Tree e3, Tree e4);
Tree twhile(Tree e1, Tree e2);
Tree exct(Tree tp);
void free_tree(Tree tp);

