#include <ugens.h>
#include <sfheader.h>
#include <stdio.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>

#define ARRSIZE 16384

extern SFHEADER sfdesc[NFILES];

/* combit --  comb filter instrument
   *
   * p0 = output skip
   * p1 = input skip
   * p2 = input duration
   * p3 = amplitude multiplier
   * p4 = pitch (cps)
   * p5 = reverb time
   * p6 = input channel [optional]
   * p7 = stereo spread [optional]
   *
 */


double combit(p, n_args)
float *p;
{
   long i, nsamps, nend, n, smps = 0;
   float loopt, xin[2], out[2];
   float amp, val, combarr[ARRSIZE];
   int j, skip, chans, inchan;
   float *array, tabs[2];
   extern struct stat sfst[NFILES];

   nsamps = setnote(p[1], p[2], 0);
   setnote(p[0], p[2], 1);

   if (p[2] == 0)      /* old feature -- if p2 is 0 will do the whole file */
      p[2] = (float) (sfst[0].st_size - getheadersize(&sfdesc[0])
                 / (float) sfclass(&sfdesc[0]) / (float) sfchans(&sfdesc[0])
                 / sfsrate(&sfdesc[0])) - p[0];
   loopt = 1.0 / p[4];
   combset(loopt, p[5], 0, combarr);

	array = floc(1);
   if (array) {
      int asize = fsize(1);
      tableset(p[2] + p[5], asize, tabs);
   }
   else
      advise("combit", "Setting phrase curve to all 1's.");

   amp = p[3];
   skip = SR / (float) resetval;
   inchan = p[6];
   j = 0;
   for (i = 0; i < nsamps; i++) {
      GETIN(xin, 0);
      while (!j--) {
         if (array)
            val = tablei(smps, array, tabs) * amp;
         else
            val = amp;
         j = skip;
         smps += skip;
      }
      out[0] = comb(xin[inchan], combarr) * val;
      if (sfchans(&sfdesc[1]) == 2) {
         out[1] = out[0] * (1.0 - p[7]);
         out[0] *= p[7];
      }
      ADDOUT(out, 1);
   }

   nend = p[5] * SR;
   for (i = 0; i < nend; i++) {
      xin[inchan] = 0.0;
      while (!j--) {
         if (array)
            val = tablei(smps, array, tabs) * amp;
         else
            val = amp;
         j = skip;
         smps += skip;
      }
      out[0] = comb(xin[inchan], combarr) * val;
      if (sfchans(&sfdesc[1]) == 2) {
         out[1] = out[0] * (1.0 - p[7]);
         out[0] *= p[7];
      }
      ADDOUT(out, 1);
   }
   endnote(1);
}


profile()
{
   UG_INTRO("combit", combit);
}
