#include <ugens.h>
#include <sfheader.h>
#include <stdio.h>

/* del1: single delay instrument
*	into stereo output
*
*  p0 = output start time
*  p1 = input start time
*  p2 = duration
*  p3 = amplitude multiplier
*  p4 = delay time
*  p5 = delay amplitude multiplier
*  p6 = input channel number <optional>
*  assumes function slot 1 is the amplitude envelope
*/

#define ARRSIZE 16384
extern SFHEADER      sfdesc[NFILES];

double del1(p,n_args)
float p[];
int n_args;
{
	long i,nsamps,n,m,count,smps = 0;
	long delsamps;
	float amp,val,wait,delamp;
	int deltabs[2],j;
	float in[2*ARRSIZE],out[2*ARRSIZE];
	float *delarray;
	float *amparr,amptabs[2];
	int inchans,outchans,inch,skip;
	extern int resetval;


	setnote(p[1],p[2],0);
	nsamps = setnote(p[0],p[2],1);

	inchans = sfchans(&sfdesc[0]);
	outchans = sfchans(&sfdesc[1]);
	if (outchans != 2) {
		fprintf(stderr,"output must be stereo!!!!!!!\n");
		return(-1);
		}

	delsamps = p[4]*SR;
	if( (delarray = (float *)malloc(delsamps * sizeof(float))) == NULL ) {
		fprintf(stderr,"Sorry, Charlie -- no space\n");
		exit(-1);
		}
	wait = p[4];
	delamp = p[5];
	delset(delarray,deltabs,wait);

	amparr = floc(1);
	if (amparr) {
		int lenamp = fsize(1);
		tableset(p[2], lenamp, amptabs);
	}
	else
		advise("del1", "Setting phrase curve to all 1's.");

	skip = SR/(float)resetval;
	j = 0;
	amp = p[3];
	inch = 0;
	if (n_args > 6) inch = p[6];
        if ((inch+1) > inchans) {
		fprintf(stderr,"uh oh, you have asked for channel %d of a %d-channel file...\n",inch,inchans);
		exit(-1);
		}
	for (i = nsamps; i > 0; i -= ARRSIZE) {
		count = (i < ARRSIZE) ? i : ARRSIZE;
		count *= inchans;
		bgetin(in,0,count);
		m = 0;
                for (n = 0; n < count; n += inchans) {
                        while (!j--) {
                                if (amparr)
											  val = tablei(smps,amparr,amptabs) * amp;
                                else
                                   val = amp;
                                j = skip;
                                smps += skip;
                                }
			in[n+inch] *= val;
			out[m] = in[n+inch];
			out[m+1] = delget(delarray, wait, deltabs) * delamp;
			delput(in[n+inch], delarray, deltabs);
			m += outchans;
			}
                baddout(out,1,count*2/inchans);
                }
	
	nsamps = wait * SR;
	for (i = 0; i < nsamps; i++) {
		out[0] = 0;
		out[1] = delget(delarray, wait, deltabs) * delamp;
		ADDOUT(out,1);
		delput(out[0], delarray, deltabs);
		}

	endnote(1);
}


profile()
{
	UG_INTRO("del1",del1);
}

