#include <ugens.h>
#include <sfheader.h>
#include <stdio.h>

extern SFHEADER      sfdesc[NFILES];

/* fir: simple fir filter instrument
*
*  p0 = outsk 
*  p1 = insk 
*  p2 = dur
*  p3 = total number of coefficients
*  p4...  the coefficients (up to 99 fir coefficients)
*
*  (no amplitude control, does channel 0 of both input and output only)
*
*/


double fir(p, n_args)
float p[];
int n_args;
{
	int i,j,nsamps;
	float in[2],out[2];
	float xn[101];
	int ncoefs;

	nsamps = setnote(p[0], p[2], 1);
	setnote(p[1], p[2], 0);
	ncoefs = p[3];

	for (j = 0; i < ncoefs; j++) xn[j] = 0.0;

	for (i = 0; i < nsamps; i++) {
		GETIN(in, 0);
		out[0] = in[0] * p[4];
		xn[0] = in[0];
		for (j= 0; i < ncoefs; j++) {
			out[0] += xn[j+1] * p[j+5];
			xn[j+1] = xn[j];
			}
		ADDOUT(out, 1);
		}

	endnote(1);
}


profile()
{
	UG_INTRO("fir",fir);
}

