#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define FORWARD 1
#define INVERSE 0

typedef struct { float re; float im; } complex;

#define CABS(x) hypot( (x).re, (x).im )

complex cadd(), csub(), cmult(), smult(), cdiv(), conjg(), csqrt();

extern complex zero;
extern complex one;
extern float synt;
extern float TWOPI;

/*
 * memory allocation macro
 */
#define fvec( name, size )\
if ( ( name = (float *) calloc( size, sizeof(float) ) ) == NULL) {\
    fprintf( stderr, "Insufficient memory\n" );\
    exit( -1 );\
}

/* prototypes */
void pvmain(float p[], int n_args);
void findroots(complex a[], complex r[], int M);
complex scmult(float s, complex x);
void makewindows(float H[], float A[], float S[], int Nw, int N, int I, int osc);
int shiftin(float A[], int N, int D);
void shiftout(float A[], int N, int I, int n);
void init_oscbank(void);
void oscbank(float C[], int N, float lpcoef[], int npoles,
         int R, int Nw, int I, float P, float O[]);
int readinput(float array[], int size);
void rfft(float x[], int N, int forward);
void cfft(float x[], int NC, int forward);
void convert(float S[], float C[], int N2, int D, int R);
void unconvert(float C[], float S[], int N2, int I, int R);
void fold(float I[], float W[], int Nw, float O[], int N, int n);
void overlapadd(float I[], int N, float W[], float O[], int Nw, int n);
float lpa(float x[], int N, float b[], int M);
