/* flange -- a stereo flanger instrument
*
*  p0 = output skip
*  p1 = input skip
*  p2 = input duration
*  p3 = amplitude multiplier
*  p4 = flange frequency (hertz)
*  p5 = flange regeneration (<1)
*  p6 = flange delay (seconds)
*  p7 = input channel [optional]
*  p8 = stereo spread (0-1) [optional]
*
*  assumes function 1 is overall amplitude envelope (or use setline)
*  assumes function 2 is flange cycle  [NOTE: used to be function 1!]
*  output file must be stereo (for now)
*
*/
load("flange")

input("/sndh/bob.dole.mono.snd")
output("/sndh/bob.dole.flanged.snd")

setline(0,0, 1,1, 4,1, 5,0)
makegen(2,10,512,1)
flange(0, 0, 5, 1, .5, .7, .05, 0, 0)
flange(1, 0, 5, 1, .9, .7, .05, 1, 1)
